#include "CivGraphFactory.h"
#include "CivGraphList.h"
#include "CivDbConn.h"
#include "CivPgConn.h"

CivGraphFactory::CivGraphFactory()
{

}

bool CivGraphFactory::createGraph(CivDbConn* dbConn,  ALGraph<CivGraphJunction, CivGraphEdage>* graph)
{
	if (dbConn == nullptr)
		return false;

	if (graph == nullptr)
		return false;

	// 
	CivCoordinates coords;
	dbConn->getCoordinates(coords);

	std::list<CivCoordinates::CoordTable> coordTableLis = coords.mTables;
	std::list<CivCoordinates::CoordTable>::iterator iter;
	for (iter = coordTableLis.begin(); iter != coordTableLis.end(); iter++)
	{
		CivCoordinates::CoordTable coordTable = *iter;

		// 붥
		CivGraphJunction graphJunction(coordTable.ID, coordTable.XCoord, coordTable.YCoord);
		graph->insertAVertex(graphJunction);
	}

	// ܶ
	CivPipe civPipe;
	dbConn->getPipe(civPipe);

	std::list<CivPipe::PipesTable> pipesTableLis = civPipe.mTables;
	std::list<CivPipe::PipesTable>::iterator pIter;
	for (pIter = pipesTableLis.begin(); pIter != pipesTableLis.end(); pIter++)
	{
		CivPipe::PipesTable pipeTable = *pIter;

		// ȡܶ
		CivGraphJunction graphJunction1(pipeTable.Node1);
		int index1 = graph->getVertexIndex(graphJunction1);
		CivGraphJunction sStartjuction = graph->getData(index1);

		// ȡܶյֵ
		CivGraphJunction graphJunction2(pipeTable.Node2);
		int index2 = graph->getVertexIndex(graphJunction2);
		CivGraphJunction endJunction = graph->getData(index2);

		
		CivGraphEdage edAge(pipeTable.ID, pipeTable.Length, { sStartjuction.getXCoord(),sStartjuction.getYCoord(),endJunction.getXCoord(),endJunction.getYCoord()});
		graph->insertAEdge(sStartjuction, endJunction, edAge);
	}

	return true;
}